import * as tracing_1 from "@effect-ts/core/Tracing";
const fileName_1 = "packages/@contentlayer/source-notion/src/fetchData/index.ts";
import * as os from 'node:os';
import * as core from '@contentlayer/core';
import { Chunk, OT, pipe, T } from '@contentlayer/utils/effect';
import * as notion from '@notionhq/client';
import { UnknownNotionError } from '../errors.js';
import { makeCacheItem } from './page.js';
export const fetchAllDocuments = ({ client, renderer, schemaDef, databaseTypeDefs, options, }) => (T.mapError_(OT.withSpan('@contentlayer/source-notion/fetchData:fetchAllDocuments', {
    attributes: { schemadef: JSON.stringify(schemaDef) },
})(T.gen(function* ($) {
    const entries = [];
    for (const databaseDef of databaseTypeDefs) {
        const result = yield* $(fetchDatabasePages({ client, databaseDef }), fileName_1 + ":38:32");
        entries.push(...result.map((page) => ({
            page,
            documentTypeDef: schemaDef.documentTypeDefMap[databaseDef.name],
            databaseTypeDef: databaseDef,
        })));
    }
    const concurrencyLimit = os.cpus().length;
    const documents = yield* $((OT.withSpan('@contentlayer/source-notion/fetchData:makeCacheItems', {
        attributes: { count: entries.length },
    })(T.forEachParN_(entries, concurrencyLimit, ({ page, documentTypeDef, databaseTypeDef }) => makeCacheItem({
        client,
        page,
        renderer,
        documentTypeDef,
        options,
        databaseTypeDef,
    }), fileName_1 + ":53:24"))), fileName_1 + ":50:33");
    const cacheItemsMap = Object.fromEntries(Chunk.map_(documents, (_) => [_.document._id, _]));
    return { cacheItemsMap };
}, fileName_1 + ":30:10")), (error) => new core.SourceFetchDataError({ error, alreadyHandled: false }), fileName_1 + ":76:15"));
const fetchDatabasePages = ({ client, databaseDef, }) => (T.mapError_(OT.withSpan('@contentlayer/source-contentlayer/fetchData:getAllEntries')(
// TODO : Use iteratePaginatedResult to process N pages by N pages to avoid storing in-memory all pages.
T.tryPromise(() => notion
    .collectPaginatedAPI(client.databases.query, {
    database_id: databaseDef.databaseId,
    filter: databaseDef.query?.filter,
    sorts: databaseDef.query?.sorts,
})
    .then((res) => res), fileName_1 + ":88:17")), (error) => new UnknownNotionError({ error }), fileName_1 + ":98:15"));
//# sourceMappingURL=index.js.map