import * as tracing_1 from "@effect-ts/core/Tracing";
const fileName_1 = "packages/@contentlayer/source-notion/src/index.ts";
import { processArgs } from '@contentlayer/core';
import { pipe, S, T } from '@contentlayer/utils/effect';
import { NotionRenderer } from '@notion-render/client';
import { fetchAllDocuments } from './fetchData/index.js';
import { provideSchema } from './schema/provideSchema.js';
export * from './schema/types.js';
export const makeSource = async (args) => {
    const { options, extensions, restArgs: { client, databaseTypes, ...rest }, } = await processArgs(args);
    const databaseTypeDefs = (Array.isArray(databaseTypes) ? databaseTypes : Object.values(databaseTypes))
        .map((_) => _.def())
        .map((databaseTypeDef) => ({
        ...databaseTypeDef,
        fields: databaseTypeDef.fields
            ? Array.isArray(databaseTypeDef.fields)
                ? databaseTypeDef.fields
                : Object.entries(databaseTypeDef.fields).map(([key, field]) => ({
                    key,
                    ...field,
                }))
            : [],
    }));
    const renderer = rest.renderer ?? new NotionRenderer({ client });
    return {
        type: 'notion',
        extensions,
        options,
        provideSchema: () => provideSchema({ client, databaseTypeDefs, options }),
        fetchData: ({ schemaDef }) => (S.fromEffect((T.either(fetchAllDocuments({ client, renderer, databaseTypeDefs, schemaDef, options }), fileName_1 + ":42:114")))),
    };
};
//# sourceMappingURL=index.js.map