import * as tracing_1 from "@effect-ts/core/Tracing";
const fileName_1 = "packages/@contentlayer/source-notion/src/mapping/index.ts";
import { fieldCheckbox } from './field-checkbox.js';
import { fieldCreatedBy } from './field-created-by.js';
import { fieldCreatedTime } from './field-created-time.js';
import { fieldDate } from './field-date.js';
import { fieldEmail } from './field-email.js';
import { fieldFields } from './field-files.js';
import { fieldFormula } from './field-formula.js';
import { fieldLastEditedBy } from './field-last-edited-by.js';
import { fieldLastEditedTime } from './field-last-edited-time.js';
import { fieldNumber } from './field-number.js';
import { fieldPeople } from './field-people.js';
import { fieldPhoneNumber } from './field-phone-number.js';
import { fieldRelation } from './field-relation.js';
import { fieldRichText } from './field-rich-text.js';
import { fieldSelect } from './field-select.js';
import { fieldStatus } from './field-status.js';
import { fieldTitle } from './field-title.js';
import { fieldUrl } from './field-url.js';
const FieldMapping = {
    checkbox: fieldCheckbox,
    email: fieldEmail,
    phone_number: fieldPhoneNumber,
    select: fieldSelect,
    url: fieldUrl,
    number: fieldNumber,
    title: fieldTitle,
    created_time: fieldCreatedTime,
    status: fieldStatus,
    date: fieldDate,
    last_edited_time: fieldLastEditedTime,
    rich_text: fieldRichText,
    files: fieldFields,
    people: fieldPeople,
    last_edited_by: fieldLastEditedBy,
    created_by: fieldCreatedBy,
    formula: fieldFormula,
    relation: fieldRelation,
};
export const getFieldFunctions = (type) => {
    const func = FieldMapping[type];
    if (!func) {
        console.warn(`Field type ${type} is not yet implemented`);
    }
    return func;
};
//# sourceMappingURL=index.js.map